#!/usr/bin/python
# -*- coding: utf-8 -*-

##
## coldwater.py -- the Coldwater static analyzer for the Unlikely programming language.
## $Id$
##

import sys
import getopt
from unlikely.scanner import Scanner
from unlikely.parser import ClassBaseParser
from unlikely.stdlib import stdlib

def load(filename, dump_ast=False):
    f = open(filename, "r")
    scanner = Scanner(f.read())
    f.close()
    parser = ClassBaseParser(scanner, stdlib)
    parser.parse()
    if dump_ast:
        print "---AST---"
        print str(stdlib)

def usage():
    print sys.argv[0]  + " -- the Coldwater Unlikely static analyzer"
    print "usage:"
    print "  [python] " + sys.argv[0] + " [-a] source.unlikely"
    print "  -a: dump AST"

def main(argv):
    dump_ast = False

    argv = argv[1:]

    try:
        opts, args = getopt.getopt(argv, "a", ["dump-ast"])
    except getopt.GetoptError:
        usage()
        sys.exit(2)

    for opt, arg in opts:
        if opt in ("-a", "--dump-ast"):
            dump_ast = True

    for filename in args:
        load(filename, dump_ast)

main(sys.argv)
